### org.jfree.layouting.renderer.model

# Interface BoxDefinition

Known Implementing Classes:
  DefaultBoxDefinition, EmptyBoxDefinition

`public interface BoxDefinition`

A box definition. Todo How to deal with auto-size margins?

Author:
  Thomas Morgner

  ## Method Summary

  `CSSColorValue`

  `getBackgroundColor()`

  `Border`

  `getBorder()`

  `RenderLength`

  `getMarginBottom()`

  `RenderLength`

  `getMarginLeft()`

  `RenderLength`

  `getMarginRight()`

  `RenderLength`

  `getMarginTop()`

  `RenderLength`

  `getMaximumHeight()`

  `RenderLength`

  `getMaximumWidth()`

  `RenderLength`

  `getMinimumHeight()`

  `RenderLength`

  `getMinimumWidth()`

  `RenderLength`

  `getPaddingBottom()`

  `RenderLength`

  `getPaddingLeft()`

  `RenderLength`

  `getPaddingRight()`

  `RenderLength`

  `getPaddingTop()`

  `RenderLength`

  `getPreferredHeight()`
    The preferred size is only set, if a height has been explicitly defined.

  `RenderLength`

  `getPreferredWidth()`
    The preferred size is only set, if a width has been explicitly defined.

  `boolean`

  `isEmpty()`

  `BoxDefinition[]`

  `split(int axis)`

## Method Details

### getBackgroundColor

    public CSSColorValue getBackgroundColor()

### getBorder

    public Border getBorder()

### getMarginBottom

    public RenderLength getMarginBottom()

### getMarginLeft

    public RenderLength getMarginLeft()

### getMarginRight

    public RenderLength getMarginRight()

### getMarginTop

    public RenderLength getMarginTop()

### getMaximumHeight

    public RenderLength getMaximumHeight()

### getMaximumWidth

    public RenderLength getMaximumWidth()

### getMinimumHeight

    public RenderLength getMinimumHeight()

### getMinimumWidth

    public RenderLength getMinimumWidth()

### getPaddingBottom

    public RenderLength getPaddingBottom()

### getPaddingLeft

    public RenderLength getPaddingLeft()

### getPaddingRight

    public RenderLength getPaddingRight()

### getPaddingTop

    public RenderLength getPaddingTop()

### getPreferredHeight

    public RenderLength getPreferredHeight()

> The preferred size is only set, if a height has been explicitly defined.
> Returns:

### getPreferredWidth

    public RenderLength getPreferredWidth()

> The preferred size is only set, if a width has been explicitly defined.
> Returns:

### isEmpty

    public boolean isEmpty()

### split

    public BoxDefinition[] split(int axis)